package cat.hack3.codingtests.marsrover.ui;

import cat.hack3.codingtests.marsrover.MarsRover;

import java.util.Scanner;

import static cat.hack3.codingtests.marsrover.ui.UICommons.output;

public class ClientCommandInterface {

    private final Scanner reader;
    private final RoverInitializer roverInitializer;

    public static void main(String[] args) {
        try (var userInputSource = new Scanner(System.in)) {
            ClientCommandInterface userInterface = new ClientCommandInterface(userInputSource);
            userInterface.start();
        }
    }

    public ClientCommandInterface(Scanner userInputSource) {
        reader = userInputSource;
        roverInitializer = new RoverInitializer(reader);
    }

    private void start() {
        output(PresentationMessage.INTRO);

        MarsRover rover = roverInitializer.autoInitialize();
        //MarsRover rover = roverInitializer.initializeFromUserInputs();

        var commandsPerformer = new RoverCommandsPerformer(reader, rover);
        commandsPerformer.acceptCommandsUntilExitSignal();
    }

}
